=== debian/changelog ===
rocblas (6.4.4-1) unstable; urgency=medium

  [ Andreas Hasenack ]
  * d/rules: use GPU_TARGETS instead of deprecated AMDGPU_TARGETS

  [ Christian Bayle ]
  * Use rocm-docs-build to avoid network access when building documentation
  * Add build dependancy on libdrm-dev
  * Disable offload-compress due to missing symbol errors in tests

  [ Cordell Bloor ]
  * New upstream version 6.4.4
  * Update B-D to LLVM 21 and latest ROCm stack (Closes: #1084071)
  * Drop d/p/remove-references-to-dfsg-violating-kernels.patch and
    remove Files-Excluded from d/copyright as the problem kernels
    have been removed upstream. The remaining assembly kernels appear
    to be original sources.
  * Update my email address
  * Remove inactive maintainers from uploaders
  * Add d/p/drop-Cijk_Ailk_Bjlk_4xi8-as-workaround.patch to work around
    invalid assembly in 4xi8 GEMM routines.
  * Enable Tensile lazy loading and separate architectures to reduce time
    required for library initialization.
  * Clean stray precompiled python files from upstream source before build

  [ Igor Luppi ]
  * d/librocblas-doc.docs: update build path for docs

  [ Kentaro Hayashi ]
  * Use d/watch 5

 -- Cordell Bloor <cgmb@debian.org>  Tue, 04 Nov 2025 14:29:00 -0700
