=== debian/control ===
Source: rocblas
Section: devel
Homepage: https://github.com/ROCm/rocBLAS
Priority: optional
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/rocm-team/rocblas.git
Vcs-Browser: https://salsa.debian.org/rocm-team/rocblas
Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders: Cordell Bloor <cgmb@debian.org>,
           Christian Kastner <ckk@debian.org>,
           Christian Bayle <bayle@debian.org>,
Build-Depends: debhelper-compat (= 13),
               cmake,
               gfortran,
               hipcc (>= 7.0.1~),
               libamd-comgr-dev (>= 7.0~),
               libblas-dev,
               libdrm-dev,
               libgtest-dev <!nocheck>,
               libhsa-runtime-dev (>= 6.4.3~),
               libmsgpack-cxx-dev,
               librocm-smi-dev,
               libroctx-dev,
               llvm-21,
               pkg-rocm-tools (>= 0.9.3~),
               python3-joblib,
               python3-msgpack,
               python3-venv,
               python3-yaml,
               rocm-cmake (>= 5.3.0),
Build-Depends-Indep: dh-sequence-sphinxdoc <!nodoc>,
               python3-doxysphinx <!nodoc>,
               python3-rocm-docs (>= 1.20.0-1~) <!nodoc>,
               python3-sphinx-external-toc <!nodoc>,
               libjs-jquery <!nodoc>,
               libjs-mathjax <!nodoc>,
               libjs-sphinxdoc <!nodoc>,
               libjs-underscore <!nodoc>
Rules-Requires-Root: no

Package: librocblas4
Section: libs
Architecture: amd64 arm64 ppc64el
XB-X-ROCm-GPU-Architecture: ${rocm:GPU-Architecture}
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: ROCm library for basic linear algebra - library
 rocBLAS is a library for performing basic linear algebra routines
 on AMD GPUs. It provides implementations of BLAS operations such as
 dot product (DOT), general matrix multiplication (GEMM), triangular
 matrix multiplication (TRMM), and many others. It is built on the
 AMD ROCm platform and optimized for discrete AMD GPUs. The rocBLAS
 library is implemented in the HIP programming language and is
 supplemented by tuned assembly kernels.
 .
 rocBLAS provides a C99 interface and supports operations on matrices
 of half-, single- or double-precision floating point numbers. The
 library provides variants for its routines that efficiently operate
 on batches of matrices and that support a variety of data layouts.
 .
 This package provides the AMD ROCm rocBLAS library.

Package: librocblas-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el
Depends: librocblas4 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
         libamdhip64-dev,
Suggests: librocblas-doc
Description: ROCm library for basic linear algebra - headers
 rocBLAS is a library for performing basic linear algebra routines
 on AMD GPUs. It provides implementations of BLAS operations such as
 dot product (DOT), general matrix multiplication (GEMM), triangular
 matrix multiplication (TRMM), and many others. It is built on the
 AMD ROCm platform and optimized for discrete AMD GPUs. The rocBLAS
 library is implemented in the HIP programming language and is
 supplemented by tuned assembly kernels.
 .
 rocBLAS provides a C99 interface and supports operations on matrices
 of half-, single- or double-precision floating point numbers. The
 library provides variants for its routines that efficiently operate
 on batches of matrices and that support a variety of data layouts.
 .
 This package provides the AMD ROCm rocBLAS development headers.

Package: librocblas4-bench
Section: libdevel
Architecture: amd64 arm64 ppc64el
Depends: librocblas4 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
Build-Profiles: <!nocheck>
Description: ROCm library for basic linear algebra - benchmarks
 rocBLAS is a library for performing basic linear algebra routines
 on AMD GPUs. It provides implementations of BLAS operations such as
 dot product (DOT), general matrix multiplication (GEMM), triangular
 matrix multiplication (TRMM), and many others. It is built on the
 AMD ROCm platform and optimized for discrete AMD GPUs. The rocBLAS
 library is implemented in the HIP programming language and is
 supplemented by tuned assembly kernels.
 .
 rocBLAS provides a C99 interface and supports operations on matrices
 of half-, single- or double-precision floating point numbers. The
 library provides variants for its routines that efficiently operate
 on batches of matrices and that support a variety of data layouts.
 .
 This package provides the AMD ROCm rocBLAS benchmark client used for
 gathering performance data about library functions.

Package: librocblas4-tests
Section: libdevel
Architecture: amd64 arm64 ppc64el
Depends: librocblas4 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
         librocblas4-tests-data
Build-Profiles: <!nocheck>
Description: ROCm library for basic linear algebra - tests
 rocBLAS is a library for performing basic linear algebra routines
 on AMD GPUs. It provides implementations of BLAS operations such as
 dot product (DOT), general matrix multiplication (GEMM), triangular
 matrix multiplication (TRMM), and many others. It is built on the
 AMD ROCm platform and optimized for discrete AMD GPUs. The rocBLAS
 library is implemented in the HIP programming language and is
 supplemented by tuned assembly kernels.
 .
 rocBLAS provides a C99 interface and supports operations on matrices
 of half-, single- or double-precision floating point numbers. The
 library provides variants for its routines that efficiently operate
 on batches of matrices and that support a variety of data layouts.
 .
 This package provides the AMD ROCm rocBLAS test binaries used for verifying
 that the library is functioning correctly. These binaries are only used to
 check whether rocBLAS works correctly on a given GPU, so generally speaking,
 users probably don't need this package.

Package: librocblas4-tests-data
Section: libdevel
Architecture: all
Depends: ${misc:Depends},
Build-Profiles: <!nocheck>
Description: ROCm library for basic linear algebra - test data
 rocBLAS is a library for performing basic linear algebra routines
 on AMD GPUs. It provides implementations of BLAS operations such as
 dot product (DOT), general matrix multiplication (GEMM), triangular
 matrix multiplication (TRMM), and many others. It is built on the
 AMD ROCm platform and optimized for discrete AMD GPUs. The rocBLAS
 library is implemented in the HIP programming language and is
 supplemented by tuned assembly kernels.
 .
 rocBLAS provides a C99 interface and supports operations on matrices
 of half-, single- or double-precision floating point numbers. The
 library provides variants for its routines that efficiently operate
 on batches of matrices and that support a variety of data layouts.
 .
 This package provides the data files required by the AMD ROCm rocBLAS tests.
 The tests are only used to check whether rocBLAS works correctly on a given
 GPU, so generally speaking, users probably don't need this package.

Package: librocblas-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Built-Using: ${sphinxdoc:Built-Using}
Depends: ${misc:Depends},
         ${sphinxdoc:Depends},
         libjs-mathjax,
Breaks: librocblas-dev (<< 5.5.1+dfsg-5~)
Replaces: librocblas-dev (<< 5.5.1+dfsg-5~)
Description: ROCm library for basic linear algebra - documentation
 rocBLAS is a library for performing basic linear algebra routines
 on AMD GPUs. It provides implementations of BLAS operations such as
 dot product (DOT), general matrix multiplication (GEMM), triangular
 matrix multiplication (TRMM), and many others. It is built on the
 AMD ROCm platform and optimized for discrete AMD GPUs. The rocBLAS
 library is implemented in the HIP programming language and is
 supplemented by tuned assembly kernels.
 .
 rocBLAS provides a C99 interface and supports operations on matrices
 of half-, single- or double-precision floating point numbers. The
 library provides variants for its routines that efficiently operate
 on batches of matrices and that support a variety of data layouts.
 .
 This package provides the AMD ROCm rocBLAS documentation.
