=== debian/watch ===
Version: 5

Source: https://github.com/rocm/rocblas/tags
Matching-Pattern: (?:.*?/)?rocm-@ANY_VERSION@\.tar\.gz
Dversionmangle: auto
Filenamemangle: s%.*/rocm-@ANY_VERSION@%rocblas-$1%

Component: tensile
Source: https://github.com/rocm/tensile/tags
Matching-Pattern: (?:.*?/)?rocm-@ANY_VERSION@\.tar\.gz
Dversionmangle: auto
Filenamemangle: s%.*/rocm-@ANY_VERSION@%tensile-$1%
